package ch.phoenix.oss.quarkus.commons.tracing;

import io.smallrye.config.ConfigMapping;
import io.smallrye.config.WithConverter;
import io.smallrye.config.WithDefault;
import java.util.Optional;
import java.util.Set;

@ConfigMapping(prefix = "phoenix.commons.tracing")
public interface TracingConfiguration {

    RequestFilterConfiguration requestFilter();

    interface RequestFilterConfiguration {

        Headers headers();

        interface Headers {

            Optional<Set<@WithConverter(LowerCaseStringConverter.class) String>> redact();
        }

        Path path();

        interface Path {

            @WithDefault("false")
            boolean includeRaw();
        }

        Query query();

        interface Query {
            @WithDefault("false")
            boolean includeRaw();

            Optional<Set<@WithConverter(LowerCaseStringConverter.class) String>> redact();
        }
    }
}
